<?php
/*
Title: atlas_controle.php

Controle das requisies em Ajax feitas pela interface Atlas do i3geo

A lista de atlas  definida no sistema de administrao do i3Geo ou em um arquivo XML

Recebe as requisies feitas em JavaScript (AJAX) e retorna o resultado para a interface.

As principais variveis so obtidas da seo, definida na inicializao do I3Geo. Se a varivel $map_file no for enviada, o retorno  uma mensagem linkquebrado e o fim do programa.

O parmetro "funcao" define qual a operao que ser executada (veja exemplo abaixo). esse parmetro  verificado em um bloco "switch ($funcao)".

Arquivo:

i3geo/classesphp/atlas_controle.php

Licenca:

GPL2

I3Geo Interface Integrada de Ferramentas de Geoprocessamento para Internet

Direitos Autorais Reservados (c) 2006 Ministrio do Meio Ambiente Brasil
Desenvolvedor: Edmar Moretti edmar.moretti@mma.gov.br

Este programa  software livre; voc pode redistribu-lo
e/ou modific-lo sob os termos da Licena Pblica Geral
GNU conforme publicada pela Free Software Foundation;
tanto a verso 2 da Licena.
Este programa  distribudo na expectativa de que seja til,
porm, SEM NENHUMA GARANTIA; nem mesmo a garantia implcita
de COMERCIABILIDADE OU ADEQUAO A UMA FINALIDADE ESPECFICA.
Consulte a Licena Pblica Geral do GNU para mais detalhes.
Voc deve ter recebido uma cpia da Licena Pblica Geral do
GNU junto com este programa; se no, escreva para a
Free Software Foundation, Inc., no endereo
59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.

Parametros:

funcao {string} - opo que ser executada.

g_sid {string} - id da seo PHP.

Retorno:

cp - o resultado da operao ser retornado em um objeto CPAINT.
*/
error_reporting(0);
$tempo = microtime(1);
//
// quando as funes abaixo forem utilizadas,  necessrio definir $map_file para que o programa continue.
//
//
//pega as variaveis passadas com get ou post
//
include_once("pega_variaveis.php");
if(isset($g_sid))
{
	session_name("i3GeoPHP");
	session_id($g_sid);
	session_start();
	foreach(array_keys($_SESSION) as $k)
	{
		eval("\$".$k."='".$_SESSION[$k]."';");
	}
	$postgis_mapa = $_SESSION["postgis_mapa"];
}
if (($funcao == "pegaListaDeAtlas") || ($funcao == "criaAtlas"))
{$map_file = "";}

if (!isset($atlasxml) || $atlasxml == "")// || !isset($editores))
{
	include_once("../ms_configura.php");
}
//
//ativa o php mapscript e as extenses necessrias
//se as extenses j estiverem carregadas no PHP, vc pode comentar essa linha para que o processamento fique mais rpido
//
include_once("carrega_ext.php");
include_once("../pacotes/cpaint/cpaint2.inc.php");

//
//cria objeto cpaint para uso com ajax
//
$cp = new cpaint();
$cp->set_data("");
//
//verifica se o usurio est tentando utilizar um link que no funciona mais
//
if (!isset($map_file))
{
	//nesse caso  necessrio criar o diretrio temporrio e iniciar o mapa
	$cp->set_data("linkquebrado");
	$cp->return_data();
	exit;
}
include_once("classe_vermultilayer.php");
include_once("funcoes_gerais.php");
if ($map_file != "")
{
	//
	//copia o map_file atual com outro nome para restaurar caso ocorra algum problema
	//
	copiaSeguranca($map_file);
	//
	//substitui a string de conexo
	//
	substituiCon($map_file,$postgis_mapa);
}
if($atlasxml == "")
{
	include($locaplic."/admin/php/xml.php");
	$xml = simplexml_load_string(geraXmlAtlas($locaplic,$editores));
}
else
$xml = simplexml_load_file($atlasxml);
//
//faz a busca da funo que deve ser executada
//
switch ($funcao)
{
/*
Opcao: pegaListaDeAtlas

Pega a lista de Atlas definida no arquivo xml menutemas/atlas.xml.

Parametro:

atlasxml {string} - nome do arquivo xml que contm a lista de atlas (veja em i3geo/menutemas). Se no for definido  utilizado a varivel definida em ms_configura.php
*/
	case "pegaListaDeAtlas":
		include_once("classe_atlas.php");
		$atl = new Atlas($xml,$atlasxml);
		$resultado = $atl->pegaListaDeAtlas($tituloInstituicao);
		$cp->set_data($resultado);
	break;
/*
Opcao: criaAtlas

Abre um Atlas especfico, criando o mapa e chamando a interface desejada.

Esse programa  chamado diretamente, por exemplo, i3geo/classesphp/atlas_controle.php?atlasxml=&atlasId=

Parametros:

atlasxml {string} - nome do arquivo xml que contm a lista de atlas (veja em i3geo/menutemas). Se no for definido  utilizado a varivel definida em ms_configura.php

atlasId_ {string} - identificador do atlas
*/
	case "criaAtlas":
		include_once("classe_atlas.php");
		$atlasxmltemp = $atlasxml;
		$atl = new Atlas($xml,$atlasxml);
		$res = $atl->criaAtlas($atlasId_);
		$interface = $res["interface"];
		$base = $res["base"];
		if ($interface == "")
		{
			echo "Erro. Nenhuma interface definida para esse Atlas";
			exit;
		}
		if (!isset($caminho))
		{$caminho = "../";}
		//
		// a funo gravaId ser executada no final do processo de gerao do mapa (ver ms_criamapa.php)
		//
		$executa = "gravaId";
		$temasa = "";
		include_once("../ms_criamapa.php");
		exit;
	break;
/*
Opcao: pegaListaDePranchas

Pega a lista de pranchas de um atlas especfico.

Parametros:

atlasxml {string} - nome do arquivo xml que contm a lista de atlas (veja em i3geo/menutemas). Se no for definido  utilizado a varivel definida em ms_configura.php

atlasId {string} - identificador do atlas
*/
	case "pegaListaDePranchas":
		include_once("classe_atlas.php");
		$atl = new Atlas($xml,$atlasxml);
		$resultado = $atl->pegaListaDePranchas($atlasId);
		$cp->set_data($resultado);
	break;
/*
Opcao: abrePrancha

Ativa uma prancha do atlas.

Parametros:

atlasxml {string} - nome do arquivo xml que contm a lista de atlas (veja em i3geo/menutemas). Se no for definido  utilizado a varivel definida em ms_configura.php

atlasId {string} - identificador do atlas

pranchaId {string} - identificador da prancha
*/
	case "abrePrancha":
		include_once("classe_atlas.php");
		$atl = new Atlas($xml,$atlasxml);
		$resultado = $atl->abrePrancha($atlasId,$pranchaId,$map_file,$locaplic);
		$cp->set_data($resultado);
	break;

}

if (!connection_aborted())
{
	if ($map_file != "")
	{
		restauraCon($map_file,$postgis_mapa);
	}
	$cp->return_data();
}
else
{exit();}
function gravaid()
{
	global $atlasId_,$tmpfname,$atlasxmltemp;//a variavel tmpfname vem do ms_criamapa.php
	$_SESSION["atlasId"] = $atlasId_;
	$_SESSION["utilizacgi"] = "nao";
	$_SESSION["atlasxml"] = $atlasxmltemp;
	$m = ms_newMapObj($tmpfname);
	$c = $m->numlayers;
	for ($i=0;$i < $c;++$i)
	{
		$l = $m->getlayer($i);
		$l->setmetadata("ATLAS","nao");
		$l->setmetadata("TIP","");
	}
	$m->save($tmpfname);		
}
?>